/******************************************************************************/
/*                                                                            */
/*     control.h   include file.                                              */
/*                 this file contains variables used for program control.     */
/*                                                                            */
/******************************************************************************/
/* Modified 4/92 by DBS@CWU for GRASS, X11, and multiuser support */

		/*    current line trace plus version number.   */
	double ltp_version = 4.14;           /*   +          */

        /*    configuration file contents     */
    CONFIG config;        /* contents of the config file                    */

        /*    batch/macro/exit modes & flags  */
    long batch_mode;      /* flag, 1 = batch mode = no prompts or graphics  */
    long collecting_macro;/* flag, 1 = store commands, don't execute        */
    char control_ban[32]; /* string to display identifying calling program  */
    long exit_macro;      /* flag, 1 = exit out from macro(s) to user input */
    long exit_program;    /* flag, 1 = exit program now.                    */
    long snap_input;      /* flag, 1 = snap input coords, 0 = don't snap    */
    long input_mode;      /* code for input mode:  see change_mode.c for list */

        /*    cursor key table                */
    char cursor_keys[256][STRLIST];  /* contents of the cursor keys file.   */
                                     /* The function produced by each       */
                                     /* keypress is held in the string      */
                                     /* array element for that character.   */

        /*    table of all macros             */
    char macros[MACSIZ][FNAME_LEN];  /*  a list of all user macros (commands) */
#ifdef MULTIUSER
    char my_macros[MACSIZ][FNAME_LEN]; /* list of macors from user's home dir */
#endif
    int  macro_file;                 /*  file pointer to macro being collected*/
    long macro_level;                /*  current macro level being executed. */

        /*    menu control variables          */
    char menu_item[MENUS][MENU_ITEMS][STRLIST];/* data for perm & other iems*/
    char menu_name[MENUS][STRLIST];              /* menu names in order       */
    char menu_help[MENUS][STRLIST];              /* help list for curnt menus */
    char menuset_name[STRLIST];                  /* name of current menu set  */
    long current_menu;                           /* number of current menu    */
    char perm_item[6][STRLIST] = { "save", "exit", "3", "4", "5", "6"};

        /*    stickup menu control tables      */
    long stickup1_rows, stickup1_cols; /*  dimentions of stickup menu on dig1 */
    long stickup2_rows, stickup2_cols; /*  dimentions of stickup menu on dig2 */
    double stickup1reg[4][2];          /*  registration for stkup1 (dig cords)*/
    double stickup2reg[4][2];          /*  registration for stkup2 (dig cords)*/
    char stickup1[1024 * STRLIST];     /*  contents of stickup menu on dig1   */
    char stickup2[1024 * STRLIST];     /*  contents of stickup menu on dig2   */

		/*	  malloc control variables                            */
    char *malloc_ptr[2];      /*  pointers to the beginning & just past     */
                              /*  space reserved for internal malloc(_ltp)  */
    char *mcontrol[100][2];   /*  program pointers for internal mallocs     */

		/*    undo control variables.   */
    UNDO_STRUCT undo_array[32];  /*  32 sets of mode & coords for rstr chages */
    long undo_index;             /*  last changed undo_array item.            */
