/******************************************************************************/
/*                                                                            */
/*     define.h    <fcntl.h> and LTPlus definitions (incl structures)         */
/*                                                                            */
/******************************************************************************/
/* Modified 6/92 by DBS@CWU for X11 support, Ultrix, and SunOS */

#include <fcntl.h>
#define BITPLN_MRGN     720	/* Size of margin between bit planes    */
#define BITPLN_SIZE     38400	/* Size of one bit plane */
#define BITPLN_WIDTH    80      /* width of bitplane in bytes           */
#define DIG1ABS         1       /*  gr_dev set value   */
#define DIG1REL         2       /*  gr_dev set value   */
#define DIG2ABS         3       /*  gr_dev set value   */
#define DIG2REL         4       /*  gr_dev set value   */
#define LTSMSE          5       /*  gr_dev set value for logitech serial mouse*/
#define MSSMSE          6       /*  gr_dev set value for microsoft serial mse */
#define ATTBMSE         7       /*  gr_dev set value for ATT bus mouse        */
#define X11MSE          8       /*  gr_dev set value for the X11 mouse        */
#define FALSE           0
#define TRUE            1
#define FNAME_LEN       14
#define FM_PATH         \"/usr/ltp/source/fm"
#define FC_PATH         \"/usr/ltp/source/fc"
#define IN_PATH         \"/usr/ltp/source/in"
#define INCL_PATH       \"/usr/ltp/incl"
#define KB		        4
#define KBUFSIZ         1024
#define MACSIZ          300
#define MAXTILES        14
#define MENUS           19
#define MENU_ITEMS      19
#define MENU_DISPLEN    12

#ifdef LTP_X11
#  define FNKEYS	12
#else
#  define FNKEYS	48
#endif

#define STRLIST         96
#define CNULL			(char)NULL
#define BOUNDARY        9000230
#define MAPSYMBL        9000330
#define SOILFEAT        9000130
#define LINEFEAT        9000435
#define HDRSZ           73        /* 72 plus the newline */
#define LINESZ          41        /* 40 plus the newline */
#define POINTSZ         41        /* 40 plus the newline */
#define FEATSZ          41        /* 40 plus the newline */
#define NUM_SETS        32        /* Number ot sets      */

#define RAMSPACE 1000000

#define MTEXT_SZ 1024			/* size of message for ipc */
#define FROMDAEMON 2
#define TODAEMON 1
#define LTPQID "LTPQID"

#define READ O_RDONLY
#define WRITE O_WRONLY
#define APPEND O_APPEND|O_WRONLY
#define RDWR O_RDWR

#ifdef SV32 
#define SYNC O_SYNC
#endif
 
#ifdef SCO_UNIX
#define SYNC O_SYNC
#endif

#ifdef ULTRIX
#define SYNC O_FSYNC
#endif

#ifdef SUNOS
#define SYNC O_SYNC
#endif

#ifndef SYNC               /* if none of the others where found use this */
#define SYNC O_SYNCW
#endif

#ifndef REDHAT51
  extern char *ioctl();    /*  removes some indirection warnings  */
#endif

typedef struct
	{	long mode;
		long x2,y2,x1,y1,x,y;
	} UNDO_STRUCT;

typedef struct 			/* used for ipc messages */
	{	
		int mtype;
		char mtext[MTEXT_SZ];
	} MSG_ST;

typedef struct			/* used for calls to obj_count */
	{	
		long nodes;
		long segments;
		long int_polys;
		long others;
	}	OBJ_CNT;

typedef struct
	{
		char button;
		long tile_num;
		long rawcoord[2];
		long scoord[2];
		long tcoord[2];
	}  GINFO;

typedef struct 
	{
		char prtr_adr[STRLIST];
		char prtr_type[STRLIST];
		char crt_adr[STRLIST];
		char crt_type[STRLIST];
		char bkup11[STRLIST];
		char bkup12[STRLIST];
		char bkup21[STRLIST];
		char bkup22[STRLIST];
		char print1[STRLIST];
		char print2[STRLIST];
		char edit1[STRLIST];
		char edit2[STRLIST];
		char cursor_file[STRLIST];
		char mouse_adr[STRLIST];
		char mouse_type[STRLIST];
		char dig1_adr[STRLIST];
		char dig1_type[STRLIST];
		char dig2_adr[STRLIST];
		char dig2_type[STRLIST];
		char plt1_adr[STRLIST];
		char plt1_type[STRLIST];
		char plt2_adr[STRLIST];
		char plt2_type[STRLIST];
		char maps_path[STRLIST];
		char bkup_path[STRLIST];
		char data3_path[STRLIST];
		char data4_path[STRLIST];
		char export_path[STRLIST];
		char import_path[STRLIST];
		char malloc[STRLIST];
		char menuset[STRLIST];
		char ginput[STRLIST];
		char rasterh[STRLIST];
		char rasterw[STRLIST];
		char pen0[STRLIST];
		char pen1[STRLIST];
		char pen2[STRLIST];
		char pen3[STRLIST];
		char pen4[STRLIST];
		char pen5[STRLIST];
		char pen6[STRLIST];
		char pen7[STRLIST];
		char pen8[STRLIST];
		char tile1[STRLIST];
		char tile2[STRLIST];
		char tile3[STRLIST];
		char tile4[STRLIST];
		char tile5[STRLIST];
		char tile6[STRLIST];
		char tile7[STRLIST];
		char tile8[STRLIST];
		char tile9[STRLIST];
		char tile10[STRLIST];
		char tile11[STRLIST];
	} CONFIG;


typedef struct
	{
	char comments[STRLIST];
	char compress[STRLIST];
	char contour_interval[STRLIST];
	char datum[STRLIST];
	char dictionary[STRLIST];
	char edgematch[STRLIST];
	char edge_e[STRLIST];
	char edge_n[STRLIST];
	char edge_s[STRLIST];
	char edge_w[STRLIST];
	char grass_mapset[STRLIST];
	char head1[STRLIST];
	char head2[STRLIST];
	char layer_name[STRLIST];
	char map_ht[STRLIST];
	char map_wd[STRLIST];
	char maptype[STRLIST];
	char menu_set[STRLIST];
	char org[STRLIST];
	char quad_unit[STRLIST];
	char revision_yr[STRLIST];
	char scale[STRLIST];
	char search_rad[STRLIST];
	char source_yr[STRLIST];
	char state[STRLIST];
	char stplzn[STRLIST];
	char template1[STRLIST];
	char template2[STRLIST];
	char template3[STRLIST];
	char udrn[STRLIST];
	char utmln[STRLIST];
	char utmlt[STRLIST];
	} HEADER;

typedef struct
	{
		char *malloc;        /*   pointer to malloc'd space  */ 
		char *rec0;          /*   pointer to beginning record  */     
		char *recn;          /*   pointer to first byte BEYOND malloc'd space*/
		long rec_size;       /*   size (in bytes) of each record  */
	}  MALLOC_STRUCT;

typedef struct
	{
		long x[2];
		long y[2];
	}  TILECOORDS;

typedef struct
	{
		long lower_leftx;   /*  lower left raster x coordinate displayed  */
		long lower_lefty;   /*  lower left raster y coordinate displayed  */
		double zoom_factor; /*  linear factor (k):  raster * k = screen len */
                            /*  =8 for zoom res, =1 for full, =.25 etc.  */
	}  VIEW;

typedef struct
	{
		double units_per_inch;         /*  digitizer units per inch          */
		long sync_col[10];             /*  10 column positions corrisponding */
                                       /*  to the 10 characters above.       */
		long baud;                     /*  baud rate of digitizer serial prt */
		long debounce;                 /*  loop control to debounce buttons  */
		long hi_x_col;                 /*  column separate hi bits are in    */
		long hi_y_col;                 /*  column separate hi bits are in    */
		long length;                   /*  fixed dig string length (or 0)    */
		long button;                   /*  column number of button info.     */
		long x_begin;                  /*  first column number of x coord.   */
		               /*  For BINARY, this is the high order byte.          */
		long x_end;                    /*  last column number of x coord.    */
		               /*  For BINARY, this is the low  order byte.          */
		long y_begin;                  /*  first column number of y coord.   */
		               /*  For BINARY, this is the high order byte.          */
		long y_end;                    /*  last column number of y coord.    */
		               /*  For BINARY, this is the low  order byte.          */
		long a_begin;                  /*  first column number of attribute. */
		long a_end;                    /*  last column number of attribute.  */
		long xmask_bits[10];           /*  specifies number of bits per mask */
                                       /*  xmask[0] resrved for hi_x_col mask */
		long ymask_bits[10];           /*  specifies number of bits per mask */
                                       /*  ymask[0] resrved for hi_y_col mask */
		char format[32];               /*  Specifies 'binary' or 'ascii'     */
		                               /*  The default is 'ascii'            */
		char digcursor[STRLIST];       /*  filename of cursor_keys file to   */
                                       /*  use when in ginput 1 or 2 mode.   */
		char start[10][STRLIST];       /*  string(s) to initialize digitizer */
		char stop[10][STRLIST];        /*  string(s) to close-out digitizer  */
		char sync_char[10];            /*  up to 10 fixed characters to be   */
                     /*  used to check for legit strings. ASCII FORMAT ONLY  */
		unsigned char sync_mask;       /*  binary pattern to be used to      */
                     /*  flag the beginning of strings    BINARY FORMAT ONLY */
		unsigned char xmask[10];       /*  up to 10 binary patterns  to be   */
                     /*  used to extract the binary values for the x coord.  */
                     /*  xmask[0] reserved for hi_x_col mask                 */
                     /*  BINARY FORMAT USE ONLY                              */
		unsigned char ymask[10];       /*  up to 10 binary patterns  to be   */
                     /*  used to extract the binary values for the y coord.  */
                     /*  ymask[0] reserved for hi_y_col mask                 */
                     /*  BINARY FORMAT USE ONLY                              */
		unsigned char button_mask;     /*  binary pattern used to extract    */
                     /*  the button press value.  BINARY FORMAT USE ONLY     */
	} DIGINFO;



/*****   The following structures correspond to the records of the variable 
	length binary files which make up some of the files for a map in 
	Line Trace. 
	Note:  there are no structures defined for the files SEG_LIST or
	INDEX_ARRAY because these records consist of 1 long integer.   ********/

typedef struct
	{	long i12[12];
		float f4[4]; 
	} OBJECTS;    	/* structure for OBJECT file records         */

typedef struct
	{	float x;
		float y;
	} COORD_LIST;	 /* structure for COORD_LIST file records         */

typedef struct
	{	long int next;
		char string[32];
	} ATTRIBUTES;	 /* structure for ATTRIBUTE file records         */

typedef struct
	{	float x;
		float y;
		long int type;
	} ERRORS;	 /* structure for ERRORS file records         */

typedef struct
	{	long int type;
		long int obj_rec;
		long int v1;
		long int v2;
		long int next;
	} INDEX_LIST;	 /* structure for INDEX_LIST file records         */

typedef struct
	{	long int type;
		long int v1;
		long int v2;
		long int atr;
	} V_OBJECTS;	 /* structure for V_OBJECTS file records         */
