/******************************************************************************/
/*              graphics.h  header file                                       */
/*              graphics related variables                                    */
/******************************************************************************/

long map_type;         /*  bit flags:  bit 0=point, 1=line, 2=polygon  */
long anchorx;          /*  raster anchor x coordinate (rubber box/line) */
long anchory;          /*  raster anchor y coordinate (rubber box/line) */
long anchor2x;         /*  secondary anchor x coordinate (wedge)        */
long anchor2y;         /*  secondary anchor y coordinate (wedge)        */
long last_raster_x;         /*  last raster x at input mode execution.       */
long last_raster_y;         /*  last raster y at input mode execution.       */
long first_point;      /*  first point still needed for current input mode   */
long search_radius;    /*  snap etc search radius, raster pixels        */
long cursor_mode=0;    /*  flag for cursor mode:  0 = cross             */
                       /*                         1 = rubberline        */
                       /*                         2 = rubberbox         */
                       /*                         3 = rubber wedge      */
                       /*                         4 = cross + hglt sgmnt*/
                       /*                         5 = cross anch + cross*/
                      /* 16 color values 0-255 for 4 bitplane combinations */
long colors[16] = { 1, 63, 2, 63, 0, 63, 4, 63, 6, 63, 58, 63, 60 ,63 ,60 ,63 };
long graphics_flag;   /*  flag, 0 = graphics are now off, ( 1 = on )   */
long disp_coord_type=0;/*  register corner type to disp coords (-1 = none )  */

int fdvga = -1;             /*  file pointer to the vga card                 */

long last_res_code;    /*  code for last different resolution displayed */

long logo_on = 1;      /*  flag indicating LTP logo is being displayed  */

long resolution_code;  /*  code for current displayed pixel resolution: */
                       /*             0 = whole map  (1:1 or smaller)   */
                       /*             1 = 1:4                           */
                       /*             2 = 1:1       (full resolution)   */
                       /*             3 = 8:1       (zoom resolution)   */

                       /*  raster coords of window for map display      */
long rwindowxmax,rwindowxmin,rwindowymax,rwindowymin;

                       /*  pointer to save area for graphic screen      */
                       /*  when in alpha mode.  used by graphics_on/off */
char scratch_pad[4][38400];

long full_width_disp;  /*  flag for full width dispaly (1=full width)     */
long disp_raster = 1;  /*  flag for displaying raster                       */
long disp_centroid = 0;  /*  flag for displaying raster                       */
long disp_hglight;     /*  bit flags for vector objects to be highlighted */
long disp_normal;      /*  bit flags for vector objects with normal display */
					/**    meaning of bit flags:
							bit 0:   display all map type objects  
							bits 1-24   display set (set # same as bit #)
							bit 25:  display objects with 1+ attributes
							bit 26:  display objects w/o any attributes    
							bit 27:  display objects with 2+ attributes
							bit 28:  display objects with <2 attributes
							bit 29:  segments with same poly rt & lt  
							bit 30 & 31,  reserved    ****/
long disp_i1normal;     /* bit flags for normal/highlight display of imported */
long disp_i2normal;     /* vector objects.  i1normal/hglight corrisponds      */
long disp_i1hglight;    /* to levels 32-63,   i2normal/hglight corrisponds    */
long disp_i2hglight;    /* to levels 64-95.      ***/

long horz_marker;      /*  screen x coord of horizontal (tile 8) marker */
long vert_marker;      /*  screen y coord of vertical (tile 9) marker   */
char text_buf[128][STRLIST];	/*  for tile 4 strings.  Allows scrolling   */
long t4_indx;          /*  index into text_buf.                    */

VIEW view[4];          /*  most recent lower_leftx and y for each res.  */
                       /*     and the zoom power for each resolution.   */
char *vga_plane = 0;       /*  pointer to vga bitplane, mapped to.          */

                       /*  screen coords of window for map display      */
long windowxmax=623,windowxmin=224,windowymax=399,windowymin=0;
