/******************************************************************************/
/*                                                                            */
/*     input.h     include file.                                              */
/*                 Common variables used for graphics and keyboard input.     */
/*                                                                            */
/******************************************************************************/
#ifdef SV32
#include <sys/types.h>
#include <sys/at_ansi.h>
#include <sys/kd.h>
#endif

char delim_buf[] = {			
		'\01', '\02', '\03', '\04', '\05', '\06', '\07', '\010', '\011',
'\012', '\013', '\014', '\015', '\016', '\017', '\020', '\021', '\022', '\023',
'\024', '\025', '\026', '\027', '\030', '\031', '\032', '\033', '\034', '\035',
'\036', '\037', '\040', 0 
	};

/**  This variable is used by input routines                 **/

long which_buf;
TILECOORDS tcoords[MAXTILES] = { 224.0, 623.0, 0.0, 399.0,
				0.0, 112.0, 0.0, 64.0,
				0.0, 112.0, 64.0, 96.0,
				120.0, 216.0, 0.0, 96.0,
				0.0, 640.0, 416.0, 480.0,
				0.0, 96.0, 112.0, 416.0,
				120.0, 216.0, 112.0, 416.0,
				96.0, 120.0, 112.0, 416.0,
				224.0, 624.0, 400.0, 416.0,
				624.0, 640.0, 0.0, 400.0,
				624.0, 640.0, 400.0, 416.0,
				0.0, 0.0, 0.0, 0.0,
				0.0, 0.0, 0.0, 0.0 };

/**  These vars are used by the keyboard routines            **/

long      kb_nxtwr;     /*  relative ptr to next byte in kb_buf  */
unsigned char kb_buf[KBUFSIZ]  ;   /*  buffer for cooked keyboard input     */
int       kb_origflag;  /*  mode flags of stdin.                 */
struct termio kb_tinfo; /*  used by kbsetraw's ioctl calls       */
struct termio kb_tsave; /*  original line settings of stdin      */
char raw_buf[512];      /*  holds command string for fj()        */
char atrbt_string[STRLIST]; /* current attribute for atrbt_dig mode */
long atrbt_otype;          /*  object type for atrbt_dig mode       */
long atrbt_action;         /*  action type for atrbt_dig mode       */
long elev_above;           /*  contour line above current position  */
long elev_below;           /*  contout line below current position  */
long context_elev;         /*  flag, 1=get elev from segment attribute */
long contour_interval;     /*  interval to use while setting contour atrbts. */
long plus_plus = 1;        /*  used for atrbt_ commands containing $++ string */
long plus_length;          /*  used for length of $++ string */
long entry_level;          /*  level being used for input mode         */
double mile_post;          /*  value inserted when attrbting using $mp */
float circle_radius;       /*  circle radius when digitizing circles  */

/**  This variable is used by the plotter routines                **/
int  fd_plot = -1;

/**  These vars are used by the mouse & digitizer  routines       **/

int  fd_ginput = -1;    /*  file descriptor of graphics input device */
long gr_dev;            /*  specifies the active graphics dev  */
GINFO ginfo;            /*  Cooked graphics input information */
DIGINFO diginfo;        /*  digitizer setup & interpretation information */

/**  These vars are used by and for the tiling functions       **/

long curr_menu;         /*  number of menu currently in tile 5   */
long curr_menu_item;    /*  menu item selected from tile 6       */

/**  This structure is used by the graphics_on and off routines. **/

#ifdef SV32
struct kd_memloc kdm;
#endif

/**  This array contains function key string values and original fkey values **/
#ifdef LTP_X11
#  include <X11/Xlib.h>
  KeySym fkey_vals[FNKEYS];               /* function key symbols */
#else
  unsigned char fkey_vals[FNKEYS][8];	/*  function key strings.  F1 is [0] */
#endif

#ifdef SV32
strmap_t orig_fkeys;                /* holds original function key values */
scrnmap_t orig_chars;               /* holds original character set */
#endif
