/******************************************************************************/
/*                                                                            */
/*     map.h       include file.                                              */
/*                 this file contains the globals which hold map file         */
/*                 variables.                                                 */
/*                                                                            */
/******************************************************************************/

long job_stats[100];       /* contents of the job_stats file                  */
long raster_wincrement;    /* number of 32-bit words in a raster row.       */
long raster_bincrement;    /* number of bytes in a raster row.              */

HEADER header;             /* contents of the header file (without 'item =')  */
long state_plane_zone;     /* derived from header file                       */
double map_scale;          /* Derived from the header file.                   */

char level_names[96][STRLIST];  /* contents of the level_names file  */
char history[512][STRLIST];  /* contents of the history file.                */
	/*  Note:  in this file, the array element containing the last        */
	/*  history file record is held in the job_stats file (rec 19).       */
	/*  This array (not the file) is written to in a cyclic fashion:      */
	/*  After element [511] is written, the next element written is [0].  */
	/*  (The history file is always written with the newest element on    */
        /*  line 511 and the oldest element on line 0.)                       */
long next_hist;    /*  pointer to the next (& oldest) history element (0-511)*/
                   /*  in the history[]   array.                             */

double tolerance;          /* Value to compare to rms when registering with  */
                           /* the digitizers.                                */

double corner[30][4][2];   /* contents of 1st part of the Register file       */
double stpln_params[16];   /* contents of 2nd part of Register file           */
   /*   Note:  other registration information is held in the HEADER array:    */
   /*   scale, state plane zone, utm zone lat & lon.                          */
double lat_ref;          /* latitude reference for utm zone, decimal degrees
                            N of equator.  The only part of this values that
                            matters is the sign.  + = northern hemisphere.  */
double lon_ref;          /* longitude reference for the utm zone, decimal 
                            degrees E of 0!!!  (North American latitudex will
                            be negative (or > 180).  This value will determine
                            which utm zone is used for this map.  The value
                            is set in get_header()           */
double unit_factor[10][2];  /*  pixel to other units conversion factors:
                                0 = raster pixels[0],  square raster pixels[1]
                                1 = map in.[0],  square inches[1]
                                2 = ground ft[0],  ground acres[1]
                                3 = ground mi[0],  square miles[1]
                                4 = map cm[0],  square cm[1]
                                5 = ground meters[0],  square meters[1]
                                6 = ground km[0],  square km[1]
                                7 = - unused -
                                8 = - unused -
                                9 = - unused -            *********/
