/******************************************************************************/
/*                                                                            */
/*     paths.h	   include file.                                              */
/*                 Contains the paths for the current map and ltp paths       */
/*                                                                            */
/******************************************************************************/
/* Modified 4/92 by DBS@CWU for GRASS and multiuser support */

char map_name[32];      /*   the map file directory name (without path)       */
char ltp_path[512];     /*   the path of the ltp directory                    */
char map_path[512];     /*   the path of the current map                      */
char temp_map_path[512];/*   the path of the temp file for the current map    */
char maps_path[512];    /*   the path of the maps directory                   */
char menus_path[512];   /*   the path of the menus directory                  */
char digmenus_path[512];/*   the path of the digmenus directory               */
char import_path[512];  /*   the path of the default import directory         */
char export_path[512];  /*   the path of the defulat export directory         */
char macros_path[512];  /*   the path of the macros directory                 */
#ifdef MULTIUSER
char home_path[512];    /*   the path to the user's home directory           */
#endif
#ifdef GRASS
char grass_path[512];   /* the path to the user's GRASS location/mapset      */
#endif

int objects_fd = -1;  /*   file descriptor of objects file                   */
int coord_list_fd= -1; /*   file descriptor of coord_list file                */
int seg_list_fd= -1;   /*   file descriptor of seg_list file                  */
int attributes_fd= -1; /*   file descriptor of attributes file                */
int errors_fd= -1;     /*   file descriptor of errors file                    */
int index_list_fd= -1; /*   file descriptor of index_list file                */
int v_attributes_fd= -1;  /*   file descriptor of v_attributes file           */
int v_objects_fd= -1;  /*   file descriptor of v_objects file                 */
int v_coordlist_fd= -1;/*   file descriptor of v_coordlist file               */

unsigned long **lraster;  /*  pointer*pointer array of the raster as longs    */
unsigned char **craster;  /*  pointer*pointer array of the raster as chars    */
MALLOC_STRUCT rasterm;    /*  structure controlling raster malloc space       */
unsigned char mini_raster[400][50];/*  mini-raster array                      */
MALLOC_STRUCT objectsm;   /*  structure controlling objects malloc space      */
MALLOC_STRUCT coord_listm;/*  structure controlling coord_list malloc space   */
MALLOC_STRUCT seg_listm;  /*  structure controlling seg_list malloc space   */
MALLOC_STRUCT attributesm;/*  structure controlling attributes malloc space   */
MALLOC_STRUCT errorsm;    /*  structure controlling errors malloc space   */
long **index_array;       /*  pointer*pointer array of the index array        */
MALLOC_STRUCT index_arraym;/* structure controlling index_array malloc space  */
MALLOC_STRUCT index_listm;/*  structure controlling index_list malloc space   */
MALLOC_STRUCT v_attributesm;/*structure controlling v_attributes malloc space */
MALLOC_STRUCT v_objectsm; /*  structure controlling v_objects malloc space   */
MALLOC_STRUCT v_coordlistm;/* structure controlling v_coordlist malloc space  */

char *node_lookup_ptr;    /*  pointer to malloc'd space for node_row array    */
long *node_lookup;        /*  pointer for simulated (lookup nodes) array      */
                          /*     This array has one element for each raster   */
                          /*  row.  This (long integer) element is the        */
                          /*  greatest record number of all 0,1,3,4-branch    */
                          /*  nodes in this row (or 0 if none in this row).   */
                          /*  This allows quick searching for a node whose    */
                          /*  location is known.                              */
